#ifndef SPI_H
#define SPI_H

void spi_init(void);
// void spi_write_byte(unsigned char byte);
void spi_write_word(unsigned short word);
//unsigned char spi_read_byte(void);
unsigned short spi_read_word(void);

unsigned char spi_cycle_byte(unsigned char inbyte);

static inline unsigned char spi_read_byte(void) {
  /* write dummy byte */
  SPDR = 0xFF;
  while (!(SPSR & _BV(SPIF)));
  return SPDR;
}

static inline void spi_write_byte(unsigned char byte) {
  SPDR = byte;
  while (!(SPSR & _BV(SPIF)));
}

static inline void spi_start(void) {
  // reset byte counter
  PORTB &= ~_BV(4);  // set SS low
}

static inline void spi_end(void) {
  PORTB |=  _BV(4);  // set SS high
}

#endif // SPI_H
